;### SSL/TLS δ
require './jcode.pl';
require './config.cgi';
($CERT,$CHAIN,$KEY,$CSR) = ('server.cert','intermediate.cert','server.key','server.csr');
$sslroot = "$cfg{mailroot}/sslconf";		# XMailCFG񥹥ȥ
&error(2,$sslroot) if !-d $sslroot;
$arrowB = "<img src='$idir/arrow3.gif' width=32 height=13 border=0 alt=''>";
$caroot = "$sslroot/CA";					# Ūǧڶɥ롼
$conf = 'openssl.conf';						# OpenSSLե̾
$days2 = 10000;								# Ūǧڶͭ
$days3 = 825;								# оͭ
$debug = 0;									# 1ǥǥХå⡼
$debugfile = '../temp/ssl_report.txt';		# 顼ϥե(../temp)
$der = 'ca.der';							# ŪǧڶɥХʥ(饤Ȥ˥󥹥ȡ)
$myindex = '../temp/mycerts.txt';			# ŪǧڶɤˤΥǥå
$sha = 'sha256';							# ̾르ꥺ
$top = "<div align='right'><a href='#top'><u> </u></a></div>";
$ENV{'OPENSSL_CONF'} = '';					# ưɻߤΤ
$ENV{'RANDFILE'} = '../temp/.rnd';			# .rndե
$openssl = "$cfg{xmaildir}/openssl.exe" if !$openssl;		# OpenSSLޥ
$openssl =~ s/\//\\/g if !$OS;

## ̩Ȥڥå
sub chk_pair {
	my ($data1,$file1,$data2,$file2) = @_;		# 1:̩(server.key)2:(server.cert)
	my ($tmp1,$tmp2) = ('../temp/tempKey.txt','../temp/tempCert.txt');		# ǡ¸
	my $OK;
	
	if ($data1 && open(FILE,">$tmp1")){
			print FILE $data1;
		close(FILE);
		$file1 = $tmp1;
	}
	if ($data2 && open(FILE,">$tmp2")){
			print FILE $data2;
		close(FILE);
		$file2 = $tmp2;
	}
	&html("̩ȥоꤹɬפޤ") if (!-s $file1 || !-s $file2);
	
	my ($str1,$str2,$str3);
	$str1 = `$openssl rsa -in $file1 -pubout 2>&1`;			# ̩
	$str2 = `$openssl x509 -in $file2 -pubkey 2>&1`;		# 
	$str1 =~ s/writing.+//;
	$str1 =~ s/[\n\r]//g;
	($str2) = &remove_garb($str2);
	foreach (split(/[\n\r]+/,$str2)){
		last if /^-+BEGIN CERTIFICATE-+/;
		$str3 .= $_;
	}
	# ޤϰʲǤOK
	#$str1 = `$openssl rsa -noout -modulus -in $file1|$openssl md5`;
	#$str2 = `$openssl x509 -noout -modulus -in $fil2|$openssl md5`;
	#return(1) if $str1 eq $str2;
	
	$OK = 1 if $str1 eq $str3;		# 
	$OK;
}

## ѴĶå
sub chk_ssl_env {
	# XMail/XMailCFGĶ
	# [opensslޥ] openssl.exe
	# {openssl饤֥] libeay32.dll,ssleay32.dll ޤ libcrypt-1_*.dll,libssl-1_*.dll
	# opensslȤǤlibeay21.dll,ssleay32.dllɬ(XMail¸ߤå?)
	# CA񡢥о̩DER
	%xmail = &get_env("$cfg{mailroot}/server.tab");
	$sslver = `$openssl version`;
	my $stat = $2 if $sslver =~ /(OpenSSL )*(\d)/i;
	&print_openssl_error($sslver) if !$stat;
	if ($sslver =~ /^OpenSSL (\d.+?) /i){$sslver = $1;} else {$sslver = '';}
	if (!$OS){
		my ($file1,$file2) = ('libcrypto-?_*.dll','libssl-?_*.dll');
		$ssldll++ if glob("$cfg{xmaildir}/$file1");
		$ssldll++ if glob("$cfg{xmaildir}/$file2");
		if (!$ssldll){
			$ssldll++ if glob("$ENV{SystemRoot}\\SysWOW64\\$file1");
			$ssldll++ if glob("$ENV{SystemRoot}\\SysWOW64\\$file2");
			$ssldll++ if glob("$ENV{SystemRoot}\\System32\\$file1");
			$ssldll++ if glob("$ENV{SystemRoot}\\System32\\$file2");
		}
		($file1,$file2) = ('libeay32.dll','ssleay32.dll');		# XMail v1.27ɬ
		$libeay++ if -f "$cfg{xmaildir}/$file1";
		$libeay++ if -f "$ENV{SystemRoot}\\SysWOW64\\$file1";
		$libeay++ if -f "$ENV{SystemRoot}\\System32\\$file1";
		$ssleay++ if -f "$cfg{xmaildir}/$file2";
		$ssleay++ if -f "$ENV{SystemRoot}\\SysWOW64\\$file2";
		$ssleay++ if -f "$ENV{SystemRoot}\\System32\\$file2";
	}
	$cacert = 1 if -f "$cfg{mailroot}/certs.pem";
	$cacert = 1 if (!$cacert && glob("$cfg{mailroot}/certs\\*.0"));
	$cacert2 = 1 if $xmail{SSLWantCert};
	$servercert = 1 if -f "$cfg{mailroot}/$CERT";
	$serverkey = 1 if -f "$cfg{mailroot}/$KEY";
	$stat;
}

## ǥХå
sub debug_ssl {
	my ($str1,$str2,$str3) = @_;
	
	open(FILE,">>$debugfile");
		print FILE " $str1 - $str2 ($year/$month/$mday $hour:$min)\n";
		print FILE "----------------------------------------------------------------\n";
		print FILE "$str3\n\n";
	close(FILE);
}

## **ǯ
sub get_date2 {
	my ($count) = @_;
	
	my $time = time() + 60 * 60 * 24 * $count;
	my @tmp = localtime($time);
	my ($year,$month,$day) = ($tmp[5],$tmp[4],$tmp[3]);
	$year += 1900;
	$month++;
	$month1 = sprintf("%02d",$month);
	$day1 = sprintf("%02d",$day);
	
	"$year/$month1/$day1";
}

## ɤ
sub get_template {
	my ($op1,$op2) = @_;	# op1(0:Server, 1:Client)
	my (@dirlist,@tmp);		# op2(0:Public, 1:SelfSigned, 2:SelfSignedByPrivateCA
	$op1 = 0 if $op1 eq '';
	$op2 = 0 if $op2 eq '';
	
	opendir(DIR,$sslroot);
		@dirlist = readdir(DIR);
	closedir(DIR);
	foreach my $dir (@dirlist){
		my $tab = "$sslroot/$dir/profile.tab";
		next if (!-s $tab || $dir !~ /\d{8}-\d{6}/);
		my %e = &get_env($tab,'=');
		my ($e1,$e2) = ($e{IDType},$e{CertType});
		$e1 = 0 if $e1 eq '';
		$e2 = 0 if $e2 eq '';
		next if $op1 ne "$e1";
		next if $op2 ne "$e2";
		push(@tmp,"$dir\t$e{Created}\t$e{CommonName}");
	}
	reverse(@tmp);
}

## ȥID
sub make_mystore {
	$storeid = "$year$month$mday-$hour$min$sec";
	$mystore = "$sslroot/$storeid";
	mkdir($mystore,0755);
	&error('100','񥹥ȥǤޤǤ',"$sslroot ΥǧƤ") if !-d $mystore;
}

## ̩ե$sslroot/$storeid˺
sub make_privatekey {
	my ($length,$storeid) = @_;		# $length:Ĺ
	$mystore = "$sslroot/$storeid";
	#return(1) if -s "$mystore/$KEY";
	
	my $str = time();
	my $mypass = md5_hex $str;
	mkdir($mystore,0755);
	my $tmp = `$openssl genrsa -des3 -out $mystore/$KEY -passout pass:$mypass $keylength 2>&1`;		# oepssl 1.1.*
	$tmp = `$openssl rsa -passin pass:$mypass -in $mystore/$KEY -out $mystore/$KEY 2>&1`;		# ѥե졼
	return(1) if -s "$mystore/$KEY";
}

## եå3ɽ
sub print_footer2 {
	print "</blockquote>\n";
	&print_footer();
	exit;
}

## إå2ɽ
sub print_header2 {
	my ($subtitle,$error) = @_;
	&print_header($subtitle,'','','600','600');
	print "<blockquote>\n";
	print "<p>$fs4R$alert $error$fe</p>\n" if $error;
}

## ĶԽʬSSL/TLSåȥå׼¹ǽ
sub print_invalid_env {
	print <<"EOF";
$fs2
<p>åȥå״ĶԽʬǤ<br>
顼å򻲹ͤɬפʺȤԤθܥ˥塼Ƽ¹ԤƤ</p>
$fe
EOF
	&print_footer2();
}

## OpenSSLС(0.9...)ξΥ顼ɽ
sub print_openssl_error {
	my ($ver) = @_;
	
	print <<"EOF";
<p>$fs5G$button $fs2<b>OpenSSL С 1.x ʹߤ򥤥󥹥ȡ뤷Ƥ!!</b>$fs2$fe</p>
<table border=1 cellpadding=8 cellspacing=0 width='95%'>
<tr><td bgcolor='#ffe8e8'>
<table border=0 cellpadding=0 cellspacing=2 class='doc14'>
<tr><td><p>ΥС $xmailcfg  <b>OpenSSL  1.x Сʹ</b>Υ󥹥ȡɬפȤޤ</p>
EOF
	
	print "<p>ߤΥСϰʲ̤Ǥ<br><span class='doc16'><b>$ver</b></span></p>\n" if $ver;
	
	print <<"EOF";
<p>ǿ OpenSSL եȥΥ󥹥ȡϰʲΤ褦ˤƤ</p>
<ol>
<li>ҤȤޤ $xmail  Windows ХʥǤƱƤ OpenSSL եȥ(openssl.exelibeay32.dllssleay32.dll)[XMailCFGĶ] ˥塼 "XMail 󥹥ȡե" ܤǻꤹ(XMail.exe ¸ߤ)˥󥹥ȡ뤹ɬפޤη̡XMail.exe  openssl.exelibeay32.dllssleay32.dll Ʊ¸ߤ뤳Ȥˤʤޤ</li>
<li>ǿǤ OpenSSL եȥ https://www.openssl.org ʤɤɤȰۤʤǤդξ̾磻󥹥ȡ뤷ޤ</li>
<li>󥹥ȡ뤵줿ǿǥեȥΤ<b>openssl.exe</b> ȴϢ饤֥ 1.ξ˾񤭥ԡޤϢ饤֥ OpenSSL 1.x Ǥ <b>libcrypto-1_1.dll</b>  <b>libssl-1_1.dll</b> ǡΥե̾ OpenSSL ΥСˤäưۤʤǽޤ</li>
<li>OpenSSL κǿǤ񤭥󥹥ȡ뤷Ƥ⡢¸ <b>libeay32.dll</b>  <b>ssleay32.dll</b> ϺΤޤޤˤƤXMail ³ΥեɬפȤ뤫Ǥ</li>
</ol>
</td></tr>
</table></td></tr>
</table>

<p>$fs5G$button $fs2<b>XMail ưץդƤ!!</b>$fs2$fe</p>
<table border=1 cellpadding=8 cellspacing=0 width='95%'>
<tr><td bgcolor='#ffe8e8'>
<table border=0 cellpadding=0 cellspacing=2 class='doc14'>
<tr><td>
<p>XMail ǥ饤ǧڤ򥵥ݡȤʳ [Ķ]-[XMailĶ] ΰʲưץϥ(̵)ˤƤ</p>
<p><b>&nbsp;⡼ȥۥȤ˥饤Ⱦ׵᤹ (SSLWantCert)<br>
&nbsp;⡼ȥۥȤΥ饤Ⱦ򸡾ڤ (SSLWantVerify)<br>
&nbsp;Ѿ certs.pem ե뤫 (SSLUseCertsFile)<br>
&nbsp;Ѿ certs ե⤫ (SSLUseCertsDir)</b></p>
<p>Υץͭˤ硢饤ȥեȥ(᡼)¦Ŭڤʥ饤Ⱦ񤬥󥹥ȡ뤵Ƥʤȥå˼Ԥ礬ޤ</p>
</td></tr>
</table></td></tr>
</table>
EOF
	
	&print_footer2();
	exit;
}

## WindowsĶؤηٹ
sub print_os_notice {
	print "<p>$fs2 Windows Ķξ硢ܥ˥塼ưʤǽޤ<br>\n";
	print "Windows Ķ $xmailcfg Ǻ Windows ĶǤ⤽ΤޤѤǤޤ$fe</p>\n";
}

## ߺ
sub remove_garb {
	my @tmp = @_;
	my @tmp1;
	
	foreach (@tmp){
		s/^Loading .+?state *//;
		s/</&lt;/g;
		s/>/&gt;/g;
		s/(-+[\n\r]+).+[\n\r]*$/$1/;
		push(@tmp1,$_);
	}
	
	@tmp1;
}

## openssl.conf
sub save_openssl_conf {
	my ($type,$op) = @_;		# type=server1ϼʽ̾
	# extendedKeyUsage = serverAuth,clientAuth,emailProtection,codeSigning 
	# extendedKeyUsage = 1.3.6.1.5.5.7.3.1, 1.3.6.1.5.5.7.3.2, 1.3.6.1.5.5.7.3.3,... ˤ٤?
	#   id-kp-serverAuth OID, id-kp-clientAuth OID,...
	my ($conf1,$dir) = ($conf,$caroot);
	$conf1 = $op if ($op && ($type eq 'CSR' || $type eq 'revoke'));
	$dir = $mystore if ($type ne 'CA' && $type ne 'revoke');
	
	# ̾ν
	my ($altnames,$count1,$count2) = ('',1,1);
	if ($CommonName =~ /^\d+\.\d+\.\d+\.\d$/){
		$altnames = "IP.$count2 = $CommonName\n";
		$count2++;
	} else {
		$altnames = "DNS.$count1 = $CommonName\n";
		$count1++;
	}
	if ($AltNames){
		foreach my $name (split(/[ ,:;]+/,$AltNames)){
			if ($name =~ /^\d+\.\d+\.\d+\.\d$/){
				$altnames .= "IP.$count2 = $name\n";
				$count2++;
			} else {
				$altnames .= "DNS.$count1 = $name\n";
				$count1++;
			}
		}
	}
	$altnames = "[ alt_names ]\n$altnames" if $altnames;
	
	# openssl.conf
	open(FILE,">$dir/$conf1");
		if ($type =~ /^(CA|server|client|revoke)$/){
			### CA #####
			print FILE <<"EOF";
[ ca ]
default_ca = CA_default

[ CA_default ]
dir = $caroot
certs = \$dir/certs
crl_dir = \$dir/crl
database = \$dir/index.txt
#unique_subject = no
new_certs_dir = \$dir/newcerts
certificate = \$dir/cacert.pem
serial = \$dir/serial
crlnumber = \$dir/crlnumber
crl = \$dir/crl.pem
private_key = \$dir/private/cakey.pem
x509_extensions = v3_ca
name_opt = ca_default
cert_opt = ca_default
# crl_extensions = crl_ext
default_days = 365
default_crl_days = 30
default_md = default
preserve = no
policy = policy_match

[ policy_match ]
countryName = match
stateOrProvinceName = match
organizationName = match
organizationalUnitName = optional
commonName = supplied
emailAddress = optional

[ policy_anything ]
countryName = optional
stateOrProvinceName = optional
organizationName = optional
organizationalUnitName = optional
commonName = supplied
emailAddress = optional
EOF
		}
		if ($type eq 'CA' || $type eq 'client'){
			my $stat = 'TRUE';
			$stat = 'FALSE' if $type eq 'client';
			print FILE <<"EOF";
[ req ]
default_bits = 2048
default_keyfile = private.key
distinguished_name = req_distinguished_name
attributes = req_attributes
x509_extensions = v3_ca
req_extensions = v3_req
string_mask = utf8only

[ req_distinguished_name ]
countryName = Country Name (2 letter code)
countryName_value = $Country
countryName_min = 2
countryName_max = 2
stateOrProvinceName = State or Province Name (full name)
stateOrProvinceName_value = $Province
localityName = Locality Name (eg, city)
localityName_value = $Locality
0.organizationName = Organization Name (eg, company)
0.organizationName_value = $Organization
organizationalUnitName = Organizational Unit Name (eg, section)
organizationalUnitName_value = $Unit
commonName = Common Name (eg, YOUR name)
commonName_value = $CommonName
commonName_max = 64
emailAddress = Email Address
emailAddress_value = $Email
emailAddress_max = 64

[ req_attributes ]
challengePassword = 
challengePassword_min = 4
challengePassword_max = 20
unstructuredName = 

[ usr_cert ]
basicConstraints = critical,CA:$stat
nsCertType = sslCA, emailCA
nsComment = "OpenSSL Generated Certificate"
subjectKeyIdentifier = hash
authorityKeyIdentifier = keyid,issuer
subjectAltName = \@alt_names

[ v3_req ]
basicConstraints = CA:FALSE
keyUsage = nonRepudiation, digitalSignature, keyEncipherment
extendedKeyUsage = serverAuth,clientAuth,emailProtection,codeSigning
subjectAltName = \@alt_names

[ v3_ca ]
subjectKeyIdentifier = hash
authorityKeyIdentifier = keyid:always,issuer
basicConstraints = critical,CA:true
nsCertType = sslCA, emailCA
subjectAltName = \@alt_names

[ crl_ext ]
# issuerAltName = issuer:copy
authorityKeyIdentifier = keyid:always

$altnames
EOF
		} elsif ($type eq 'CSR'){
			## CSR #####
			print FILE <<"EOF";
[req]
distinguished_name = req_distinguished_name
req_extensions = v3_req

[ v3_req ]
basicConstraints = CA:FALSE
keyUsage = nonRepudiation, digitalSignature, keyEncipherment
extendedKeyUsage = serverAuth,clientAuth,emailProtection,codeSigning
subjectAltName = \@alt_names

[req_distinguished_name]
countryName = Country Name (2 letter code)
countryName_value = $Country
countryName_default = JP
stateOrProvinceName = State or Province Name (full name)
stateOrProvinceName_value = $Province
stateOrProvinceName_default = 
localityName = Locality Name (eg, city)
localityName_value = $Locality
localityName_default = 
0.organizationName = Organization Name (eg, company)
0.organizationName_value = $Organization
O.organizationName_default = 
organizationalUnitName_value = $Unit
organizationalUnitName_default = 
commonName = Common Name (eg, YOUR name)
commonName_value = $CommonName
commonName_max = 64
emailAddress = Email Address
emailAddress_value = $Email

$altnames
EOF
		} elsif ($type eq 'server' || $type eq 'server1'){
			## о #####
			print FILE <<"EOF";
[ CA_default ]
default_ca = usr_cert

[ req ]
default_bits = 2048
default_keyfile = $KEY
distinguished_name = req_distinguished_name
attributes = req_attributes
x509_extensions = usr_cert
req_extensions = v3_req
string_mask = utf8only

[ req_distinguished_name ]
countryName = Country Name (2 letter code)
countryName_value = $Country
countryName_min = 2
countryName_max = 2
stateOrProvinceName = State or Province Name (full name)
stateOrProvinceName_value = $Province
localityName = Locality Name (eg, city)
localityName_value = $Locality
0.organizationName = Organization Name (eg, company)
0.organizationName_value = $Organization
organizationalUnitName = Organizational Unit Name (eg, section)
organizationalUnitName_value = $Unit
commonName = Common Name (eg, YOUR name)
commonName_value = $CommonName
emailAddress = Email Address
emailAddress_value = $Email

[ req_attributes ]
challengePassword = 
challengePassword_min = 4
challengePassword_max = 20
unstructuredName = 

[ usr_cert ]
basicConstraints=CA:FALSE
nsCertType = server
nsComment = "OpenSSL Generated Certificate"
subjectKeyIdentifier = hash
authorityKeyIdentifier = keyid,issuer
subjectAltName = \@alt_names

[ v3_req ]
basicConstraints = CA:FALSE
keyUsage = nonRepudiation, digitalSignature, keyEncipherment
extendedKeyUsage = serverAuth,clientAuth,emailProtection,codeSigning
subjectAltName = \@alt_names

$altnames
EOF
		} elsif ($type eq 'client'){
			## 饤Ⱦ #####
			print FILE <<"EOF";
[ CA_default ]
default_ca = usr_cert

[ req ]
default_bits = 2048
default_keyfile = $KEY
distinguished_name = req_distinguished_name
attributes = req_attributes
x509_extensions = usr_cert
req_extensions = 
string_mask = utf8only

[ req_distinguished_name ]
countryName = Country Name (2 letter code)
countryName_value = $Country
countryName_min = 2
countryName_max = 2
stateOrProvinceName = State or Province Name (full name)
stateOrProvinceName_value = $Province
localityName = Locality Name (eg, city)
localityName_value = $Locality
0.organizationName = Organization Name (eg, company)
0.organizationName_value = $Organization
organizationalUnitName = Organizational Unit Name (eg, section)
organizationalUnitName_value = $Unit
commonName = Common Name (eg, YOUR name)
commonName_value = $CommonName
emailAddress = Email Address
emailAddress_value = $Email

[ req_attributes ]
challengePassword = 
challengePassword_min = 4
challengePassword_max = 20
unstructuredName = 

[ usr_cert ]
basicConstraints=CA:FALSE
nsCertType = client,email,objsign
nsComment = "OpenSSL Generated Certificate"
subjectKeyIdentifier = hash
authorityKeyIdentifier = keyid,issuer
EOF
		} elsif ($type eq 'revoke'){
			##  #####
			print FILE <<"EOF";
[ req ]
default_bits = 2048
default_keyfile = $KEY
input_password = $i{mypass}
output_password = $i{mypass}
string_mask = utf8only
EOF
		}
	close(FILE);
}
1;
